"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.SequelizeConfiguration = void 0;
const decorator_1 = require("@midwayjs/decorator");
const dataSourceManager_1 = require("./dataSourceManager");
const core_1 = require("@midwayjs/core");
const decorator_2 = require("./decorator");
let SequelizeConfiguration = class SequelizeConfiguration {
    async init() {
        this.decoratorService.registerPropertyHandler(decorator_2.ENTITY_MODEL_KEY, (propertyName, meta) => {
            return this.dataSourceManager
                .getDataSource(meta.connectionName ||
                this.dataSourceManager.getDataSourceNameByModel(meta.modelKey))
                .getRepository(meta.modelKey);
        });
    }
    async onReady(container) {
        this.dataSourceManager = await container.getAsync(dataSourceManager_1.SequelizeDataSourceManager);
    }
    async onStop() {
        if (this.dataSourceManager) {
            await this.dataSourceManager.stop();
        }
    }
};
__decorate([
    (0, decorator_1.Config)('sequelize'),
    __metadata("design:type", Object)
], SequelizeConfiguration.prototype, "sequelizeConfig", void 0);
__decorate([
    (0, decorator_1.Inject)(),
    __metadata("design:type", core_1.MidwayDecoratorService)
], SequelizeConfiguration.prototype, "decoratorService", void 0);
__decorate([
    (0, decorator_1.Init)(),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", Promise)
], SequelizeConfiguration.prototype, "init", null);
SequelizeConfiguration = __decorate([
    (0, decorator_1.Configuration)({
        namespace: 'sequelize',
        importConfigs: [
            {
                default: {
                    sequelize: {},
                },
            },
        ],
        // importConfigFilter: config => {
        //   if (config['sequelize'] && config['sequelize']['options']) {
        //     config['sequelize'].options.sync = config['sequelize'].sync || false;
        //     const legacyDataSourceConfig = config['sequelize'].options;
        //     delete config['sequelize']['options'];
        //     config['sequelize'].dataSource = {
        //       default: legacyDataSourceConfig,
        //     };
        //   }
        //   return config;
        // },
    })
], SequelizeConfiguration);
exports.SequelizeConfiguration = SequelizeConfiguration;
//# sourceMappingURL=configuration.js.map